unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Grids,ShellApi, Inifiles, About, AppEvnts, Options;

Const
  VersionNumber = '0.95';

type
  TFByte = File of byte;

  TState = Record
    Addr,
    Size,
    WristappAddr,
    WristappSize : Integer;
    ReservedByte : Byte;
    Data : Array[0..32767] of Byte;
  End;

  TFMain = class(TForm)
    PnMain: TPanel;
    Splitter1: TSplitter;
    GroupBox1: TGroupBox;
    BtLoad: TButton;
    EdProjectName: TEdit;
    GroupBox3: TGroupBox;
    BtBuild: TButton;
    SGAnalyze: TStringGrid;
    PnMemo: TPanel;
    Memo: TMemo;
    Panel3: TPanel;
    OpenDialog: TOpenDialog;
    BtHelp: TButton;
    ApplicationEvents: TApplicationEvents;
    PnResume: TPanel;
    LbStatus: TLabel;
    LbBiggestState: TLabel;
    LbWristappSize: TLabel;
    BtOptions: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure BtLoadClick(Sender: TObject);
    procedure BtBuildClick(Sender: TObject);
    procedure SGAnalyzeDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BtHelpClick(Sender: TObject);
    procedure ApplicationEventsActivate(Sender: TObject);
    procedure SGAnalyzeDblClick(Sender: TObject);
    procedure BtOptionsClick(Sender: TObject);
  private
    { Private declarations }
    Common : TState;
    State  : Array[0..25] of TState;
    Scr : Record
      AppName,
      FolderName,
      Description,
      BannerLine,
      BannerLine2,
      VersionRequired : String;
      PasswordSupport,
      DatabaseSupport : Integer;
      PCInterface,
      HeaderDir,
      SourceDir,
      BuildDir,
      IncludeDir,
      AssemblerDir  : String;
      NbSource      : Integer;
      NbParamFile   : Integer;
      ParamFile     : Array [1..5] of String;
      NbHeaderFile  : Integer;
      HeaderFiles   : String;
      HeaderFile    : Array [1..5] of String;
      NbBackFile    : Integer;
      BackFiles     : String;
      BackFile      : Array [1..5] of String;
      NbCommonFile  : Integer;
      CommonFiles   :String;
      CommonFile    : Array [1..5] of String;
      NbStateFile   : Array [0..20] of integer;
      StateFiles    : Array [0..20] of String;
      StateFile     : Array [0..20,1..5] of String;
    end;
    NumMsg          : UINT;
    WristappSize    : Integer;

    BiggestState    : integer;
    BiggestStateNb  : Integer;
    Status          : Integer;
    Editor          : String;
    CheckSize       : Boolean;
    SaveDb       : Boolean;
    ProjectName     : String;
    ProjectDir      : String;
    NbProjectState  : Integer;
    AppDir          : String;
    ScrFileAge      : Integer;
    Procedure Msg(s:string);
    Procedure LoadState(Name:String; Var BState:TState);
    Function  GenerateWristapp(BuildDir:String;NbState:Integer):Boolean;
    Function  GenerateParam(SrcName,DstName:String):Boolean;
    Function  TestAsmOutput(BuildDir:String;NbState:Integer):Boolean;
    Function  TestAsmOutputCommon(BuildDir:String;NbState:Integer):Boolean;
    Function  TestAsmOutputState(BuildDir:String;NbState:Integer):Boolean;
    Procedure DisplayAsmError(FName:String);
    Function  TestLinkerOutput(BuildDir:String;NbState:Integer):Boolean;
    Function  TestLinkerOutputCommon(BuildDir:String;NbState:Integer):Boolean;
    Function  TestLinkerOutputParam(BuildDir:String;NbState:Integer):Boolean;
    Function  TestLinkerOutputState(BuildDir:String;NbState:Integer):Boolean;
    Function  DisplayLinkerError(StateName,FName,SrcName:String):Boolean;
    Function  FillSG(NbState:Integer):Boolean;
    Procedure InitSG;
    Procedure Build;
    procedure SaveConfiguration;
    procedure LoadConfiguration;
    Procedure LoadConfig(f:TInifile);
    Procedure SaveConfig(f:TInifile);
    Procedure LoadScr(Name:String);
    procedure TestModifSCR;
    procedure Foreground;
    procedure DisplayResume;
  public
    { Public declarations }
    procedure OnWmCopyData(var msg:TMessage); message WM_COPYDATA;
  end;

  TPDataSend=^TDataSend;
  TDataSend =Packed record  //packed pour "compress"
    Cmd:Integer;  // Command code
    Param:String[255];  // Parameter string if necessary
  end;

var
  FMain: TFMain;

implementation

{$R *.dfm}

Procedure ExecAndWait(s:String);
Var  StartInfo   : TStartupInfo;
     ProcessInfo : TProcessInformation;
     Fin         : Boolean;
Begin
  { Mise  zro de la structure StartInfo }
  FillChar(StartInfo,SizeOf(StartInfo),#0);
  { Seule la taille est renseigne, toutes les autres options }
  { laisses  zro prendront les valeurs par dfaut }
  StartInfo.cb     := SizeOf(StartInfo);

  { Lancement de la ligne de commande }
  If CreateProcess(Nil, PChar('"'+s+'"'), Nil, Nil, False,
                0, Nil, Nil, StartInfo,ProcessInfo) Then
  Begin
    { L'application est bien lance, on va en attendre la fin }
    { ProcessInfo.hProcess contient le handle du process principal de l'application }
    Fin:=False;
    Repeat
      { On attend la fin de l'application }
      Case WaitForSingleObject(ProcessInfo.hProcess, 200)Of
        WAIT_OBJECT_0 :Fin:=True; { L'application est termine, on sort }
        WAIT_TIMEOUT  :;          { elle n'est pas termine, on continue d'attendre }
      End;
      { Mise  jour de la fentre pour que l'application ne paraisse pas bloque. }
      Application.ProcessMessages;
    Until Fin;
    { C'est fini }
  End
  Else RaiseLastOSError;
End;


Function Hex2Dec(c1,c2:char):integer;
const s='0123456789ABCDEF';
Begin
  Hex2Dec:=16*(pos(c1,s)-1)+pos(c2,s)-1;
End;

Function HexAddr2Dec(s:string):Integer;
Begin
  HexAddr2Dec:=Hex2Dec(s[1],s[2])*65536+Hex2Dec(s[3],s[4])*256+Hex2Dec(s[5],s[6]);
End;

//-- Write a byte to the file --
Procedure WriteByte(Var f;b:byte);
Begin
  write(TFByte(f),b);
End;


//-- Read a word from the file --
Procedure WriteWord(Var f;w:word);
Var b,c:byte;
Begin
  b:=w mod 256;
  c:=w div 256;
  write(TFByte(f),b);
  write(TFByte(f),c);
End;


function Copy_File(source:string;cible:string;AnnuleSiExiste:Boolean):boolean;
{------------------------------------------------------------------------------}
{copie le fichier source vers le fichier cible. si le fichier cible existe dj}
{ la copie ne se fait que si AnnuleSiFichier est  false                        }
{------------------------------------------------------------------------------}
var NomSource,NomCible:array[0..255]of Char;
begin
  if not DirectoryExists(ExtractFileDir(cible)) then  ForceDirectories(ExtractFileDir(cible));
  StrPCopy(NomSource,Source);
  StrPCopy(NomCible,Cible);
  result:=CopyFile(NomSource,NomCible,AnnuleSiExiste);
end;


Procedure TFMain.Msg(s:string);
Begin
  Memo.Lines.Add(s);
End;


//-- Save the actual configuration to disk --
procedure TFMain.SaveConfiguration;
Var
  CfgIni: TIniFile;
begin
  CfgIni := TIniFile.Create(AppDir+'wBuilder.ini');
  FMain.SaveConfig(CfgIni);
  CfgIni.Free;
End;


//-- Load the actual configuration from disk --
procedure TFMain.LoadConfiguration;
Var
  CfgIni: TIniFile;

begin
  CfgIni := TIniFile.Create(AppDir+'wBuilder.ini');
  FMain.LoadConfig(CfgIni);
  CfgIni.Free;
End;


//-- Load config from config file --
Procedure TFMain.LoadConfig(f:TInifile);
Begin
  Top:=f.ReadInteger('Main','Top',0);
  Left:=f.ReadInteger('Main','Left',0);
  Height:=f.ReadInteger('Main','Height',200);
  Width:=f.ReadInteger('Main','Width',200);
  PnMain.Height:=f.ReadInteger('Main','MainHeight',150);
  SGAnalyze.ColWidths[0]:=f.ReadInteger('Main','SG_COLW0',80);
  SGAnalyze.ColWidths[1]:=f.ReadInteger('Main','SG_COLW1',80);
  SGAnalyze.ColWidths[2]:=f.ReadInteger('Main','SG_COLW2',80);
  SGAnalyze.ColWidths[3]:=f.ReadInteger('Main','SG_COLW3',80);
  SGAnalyze.ColWidths[4]:=f.ReadInteger('Main','SG_COLW4',80);
  ProjectDir:=f.ReadString('Main', 'LastProjectDir','');
  Editor:=f.ReadString('Options', 'Editor','notepad');
  CheckSize:=f.ReadBool('Options', 'CheckSize',False);
  SaveDb:=f.ReadBool('Options', 'SaveDb',True);
End;


//-- Save config to config file --
Procedure TFMain.SaveConfig(f:TInifile);
Begin
  f.WriteInteger('Main','Top',Top);
  f.WriteInteger('Main','Left',Left);
  f.WriteInteger('Main','Height',Height);
  f.WriteInteger('Main','Width',Width);
  f.WriteInteger('Main','MainHeight',PnMain.Height);
  f.WriteInteger('Main','SG_COLW0',SGAnalyze.ColWidths[0]);
  f.WriteInteger('Main','SG_COLW1',SGAnalyze.ColWidths[1]);
  f.WriteInteger('Main','SG_COLW2',SGAnalyze.ColWidths[2]);
  f.WriteInteger('Main','SG_COLW3',SGAnalyze.ColWidths[3]);
  f.WriteInteger('Main','SG_COLW4',SGAnalyze.ColWidths[4]);
  If ProjectDir<>'' then f.WriteString('Main', 'LastProjectDir',ProjectDir);
  f.WriteString('Options', 'Editor',Editor);
  f.WriteBool('Options', 'CheckSize',CheckSize);
  f.WriteBool('Options', 'SaveDb',SaveDb);
End;


//-- Called when the windows is created --
procedure TFMain.FormCreate(Sender: TObject);
Var i:integer;
begin
  AppDir:=ExtractFilePath(Application.ExeName);
  WristappSize:=0;
  ProjectName:='';
  ProjectDir:='';
  Scr.NbSource:=25;
  SGAnalyze.RowCount:=Scr.NbSource+4;
  LoadConfiguration;
  ScrFileAge:=0;
  BiggestState:=0;
  Status:=0;
  DisplayResume;
  NumMsg:=RegisterWindowMessage('wBuilder Message');

  InitSG;
  Msg('wBuilder version '+VersionNumber+' - (c) Pierre Delore');
end;


//-- Procedure called when the message WM_COPYDATA come --
procedure TFMain.OnWmCopyData(var msg: TMessage);
type
  TPCopyDataStruct=^TCopyDataStruct;
  TPDataSend=^TDataSend;
Var
  DataSend:TDataSend;
  PDataSend:TPDataSend;
  PCopyDataStruct:TPCopyDataStruct;
begin
  PCopyDataStruct:=TPCopyDataStruct(msg.LParam);
  //PCopyDataStruct^ signifie "ce qui est point par le PCopyDataStruct"
  PDataSend:=PCopyDataStruct^.lpData;
  DataSend:=PDataSend^;

  If DataSend.Cmd=1 then begin
    Foreground;
    TestModifSCR;
    Build;
  End;
  //EditReceptionTexte.Text:=DataEnvoyes.UneChaine;
  //SpinEditReceptionNombre.Value:=DataEnvoyes.UnEntier;
end;


procedure TFMain.Foreground;
Var Proc,App:Integer;
begin
  Proc:=GetWindowThreadProcessId(GetForeGroundWindow);
  App:=GetCurrentThreadID;
  If Proc<>App Then
  Begin
    // This application is not foreground
    AttachThreadInput(App,Proc,True);
    SetForeGroundWindow(Handle);
    AttachThreadInput(App,Proc,False);
    Application.BringToFront;
  End Else
  Begin
    // This application is foreground
    SetForeGroundWindow(Handle);
  End;
end;


procedure TFMain.DisplayResume;
Begin
  Case Status of
    -1  : Begin
            LbStatus.Caption:='Status: ERROR';
            PnResume.Color:=clRed;
            PnResume.Font.Color:=clYellow;
          End;
    0   : Begin
            LbStatus.Caption:='Status:';
            PnResume.Color:=clWhite;
            PnResume.Font.Color:=clBlack;
          End;
    1   : Begin
            LbStatus.Caption:='Status: OK';
            PnResume.Color:=$00FF9E; //clLime;
            PnResume.Font.Color:=clBlack;
          End;
  End; //Case

  LbBiggestState.Caption:=Format('Biggest State: State %d : Size = %d bytes',[BiggestStateNb,BiggestState]);
  LbWristappSize.Caption:=Format('Wristapp size: %d bytes',[WristappSize]);
End;


Procedure TFMain.Build;
Var  StartInfo   : TStartupInfo;
     ProcessInfo : TProcessInformation;
     Fin         : Boolean;
     S           : String;
Begin
  If ProjectName='' then exit;
  Status:=0;
  BiggestState:=0;
  WristappSize:=0;
  BiggestStateNb:=0;
  DisplayResume;

  Status:=-1;
  Memo.Lines.Clear;
  //-- Save the database --
  s:=Scr.BuildDir+'\'+Scr.FolderName+'_dbase_018.bin';
  if (Scr.DatabaseSupport=1) and SaveDb then begin
    Msg('[i] Save '+Scr.FolderName+'_dbase_018.bin to '+Scr.FolderName+'_dbase_018.bin.sav');
    Copy_File(s,s+'.sav',False);
  End;
  //-- --
  Msg('[i] Executing the "build.bat" script');
  ExecAndWait(ProjectDir+'build.bat');
{
  Msg('[i] Testing if assembler errors occured');
  If TestAsmOutput(Scr.BuildDir,NbProjectState) then begin
    Msg('[i] Testing if linker errors occured');
    If TestLinkerOutput(Scr.BuildDir,NbProjectState) then begin
}
  Msg('[i] Testing if there are common state error');
  Msg('[i] >>Testing if assembler errors occured');
  If TestAsmOutputCommon(Scr.BuildDir,NbProjectState) then begin
    Msg('[i] >>Testing if linker errors occured');
    If TestLinkerOutputCommon(Scr.BuildDir,NbProjectState) then begin
      Msg('[i] Testing if there are state error');
      Msg('[i] >>Testing if assembler errors occured');
      If TestAsmOutputState(Scr.BuildDir,NbProjectState) then begin
        Msg('[i] >>Testing if linker errors occured');
        If TestLinkerOutputState(Scr.BuildDir,NbProjectState) then begin
          Msg('[i] Testing if there are parameter error');
          Msg('[i] >>Testing if linker errors occured');
          If TestLinkerOutputParam(Scr.BuildDir,NbProjectState) then begin
            Msg('[i] Generating the Wristapp');
            GenerateWristapp(Scr.BuildDir,NbProjectState+1);
            If FillSG(NbProjectState) then begin
              Msg('[i] Generating the parameter file');
              If GenerateParam(Scr.BuildDir+'\param.sre',Scr.BuildDir+'\'+Scr.FolderName+'_par_018.bin') then begin
                Msg('[i] Compilation completed. Enjoy :-)');
                //-- Restore the database --
                if (Scr.DatabaseSupport=1) and SaveDb then begin
                  Msg('[i] Restore '+Scr.FolderName+'_dbase_018.bin.sav to '+Scr.FolderName+'_dbase_018.bin');
                  Copy_File(s+'.sav',s,False);
                End;
                //-- --
                Status:=1;
              end;
            end;
          end;
        end;
      End;
    End;
  End;
  DisplayResume;

End;


procedure TFMain.InitSG;
Var i:Integer;
Begin
  //-- String grid --
  SGAnalyze.Cells[0,0]:='Part name';
  SGAnalyze.Cells[1,0]:='Status';
  SGAnalyze.Cells[2,0]:='Size';
  SGAnalyze.Cells[3,0]:='State size';
  SGAnalyze.Cells[4,0]:='File(s)';

  SGAnalyze.Cells[0,1]:='Headers';
  SGAnalyze.Cells[1,1]:='';
  SGAnalyze.Cells[2,1]:='';
  SGAnalyze.Cells[3,1]:='';
  SGAnalyze.Cells[4,1]:='';

  SGAnalyze.Cells[0,2]:='Background';
  SGAnalyze.Cells[1,2]:='';
  SGAnalyze.Cells[2,2]:='';
  SGAnalyze.Cells[3,2]:='';
  SGAnalyze.Cells[4,2]:='';


  SGAnalyze.Cells[0,3]:='Common';
  SGAnalyze.Cells[1,3]:='';
  SGAnalyze.Cells[2,3]:='';
  SGAnalyze.Cells[3,3]:='';
  SGAnalyze.Cells[4,3]:='';

  For i:=0 to Scr.NbSource-1 do begin
    SGAnalyze.Cells[0,i+4]:='State '+intToStr(i);
    SGAnalyze.Cells[1,i+4]:='';
    SGAnalyze.Cells[2,i+4]:='';
    SGAnalyze.Cells[3,i+4]:='';
    SGAnalyze.Cells[4,i+4]:='';
  End;

End;


Function TFMain.FillSG(NbState:Integer):Boolean;
Var i,j:integer;
    ok:Boolean;

  Function TestSize(p:integer):String;
  Begin
    If p<=900
      then TestSize:='Ok'
      else TestSize:='Error';
  End;

begin
  BiggestState:=0;
  Ok:=True;
  With SGAnalyze do begin

    Cells[1,1]:='';
    Cells[2,1]:='';
    Cells[3,1]:='';
    Cells[4,1]:=Scr.HeaderFiles;

    Cells[1,2]:='';
    Cells[2,2]:='';
    Cells[3,2]:='';
    Cells[4,2]:=Scr.BackFiles;

    j:=Common.Size;
    Cells[1,3]:=TestSize(j);
    Cells[2,3]:=IntToStr(j);
    Cells[3,3]:='';
    Cells[4,3]:=Scr.CommonFiles;
    If j>900 then Begin
      Msg('[!] ERROR : Common part : Part too big (Limit at 900 bytes)');
      Ok:=False;
    End;

    For i:=0 to Scr.NbSource-1 do begin
      If (i<=NbState) then begin
        j:=State[i].Size;
        Cells[1,4+i]:=TestSize(Common.Size+j);
        Cells[2,4+i]:=IntToStr(j);
        Cells[3,4+i]:=IntToStr(Common.Size+j);
        Cells[4,4+i]:=Scr.StateFiles[i];
        If Common.Size+j>900 then Begin
          Msg(Format('[!] ERROR : State %d : State too big (Limit at 900 bytes)',[i]));
          If not CheckSize
            then Ok:=False
            else Msg('[!] The option "Don'#39't check the state size" is checked the wristapp will be generated');
        End;
        If Common.Size+j>BiggestState then begin
          BiggestState:=Common.Size+j;
          BiggestStateNb:=i;
        End;
      End
      Else Begin
        Cells[1,4+i]:='';
        Cells[2,4+i]:='';
        Cells[3,4+i]:='';
        Cells[4,4+i]:='';
      End;
    End; //For
  End; //With
  FillSG:=Ok;
end;


Procedure TFMain.DisplayAsmError(FName:String);
Var
  f : TextFile;
  s : String;
Begin
  AssignFile(f,FName);
  Reset(f);
  While not(Eof(f)) do begin
    Readln(f,s);
    If pos('as88',s)=1 then msg(s);
  End;
  CloseFile(f);
End;


Function TFMain.TestAsmOutput(BuildDir:String;NbState:Integer):Boolean;
Var i:integer;
Begin
  TestAsmOutput:=False;
  //Common
  If FileExists(BuildDir+'\Common.ers') Then Begin
    DisplayAsmError(BuildDir+'\Common.ers');
    Exit;
  End;
  // State 0..NbState
  For i:=0 to NbState do begin
    If FileExists(BuildDir+'\state'+intToStr(i)+'.ers') Then Begin
      DisplayAsmError(BuildDir+'\state'+intToStr(i)+'.ers');
      Exit;
    End;
  End;

  TestAsmOutput:=True;
End;


Function TFMain.TestAsmOutputCommon(BuildDir:String;NbState:Integer):Boolean;
Var i:integer;
Begin
  TestAsmOutputCommon:=False;
  //Common
  If FileExists(BuildDir+'\Common.ers') Then Begin
    DisplayAsmError(BuildDir+'\Common.ers');
    Exit;
  End;
  TestAsmOutputCommon:=True;
End;


Function TFMain.TestAsmOutputState(BuildDir:String;NbState:Integer):Boolean;
Var i:integer;
Begin
  TestAsmOutputState:=False;
  // State 0..NbState
  For i:=0 to NbState do begin
    If FileExists(BuildDir+'\state'+intToStr(i)+'.ers') Then Begin
      DisplayAsmError(BuildDir+'\state'+intToStr(i)+'.ers');
      Exit;
    End;
  End;
  TestAsmOutputState:=True;
End;


Function TFMain.DisplayLinkerError(StateName,FName,SrcName:String):Boolean;
Var
  f : TextFile;
  s : String;
  ok,first,error:Boolean;
Begin
  Ok:=False;
  First:=True;
  Error:=False;
  AssignFile(f,FName);
  Reset(f);
  While not(Eof(f)) do begin
    Readln(f,s);
    If  (pos('lk88 W',s)=1) or
        (pos('lk88 E',s)=1) or
        (pos('lk88 F',s)=1) then begin
          If First then begin
            msg('>>'+StateName+' ('+SrcName+')');
            First:=False;
          End;
          msg(s);
          Error:=True;
          Ok:=True;
    End
    Else if (pos('lk88 V',s)=1) then begin
      Error:=False;
    End
    Else if Error then Msg(s);
  End;
  CloseFile(f);
  DisplayLinkerError:=Ok;
End;


Function TFMain.TestLinkerOutput(BuildDir:String;NbState:Integer):Boolean;
Var i:integer;
Begin
  TestLinkerOutput:=False;
  //Common
  If FileExists(BuildDir+'\Common.elk') Then Begin
    If DisplayLinkerError('Common State',BuildDir+'\Common.elk',Scr.CommonFiles) then Exit;
  End;

  //Parameter file
  If FileExists(BuildDir+'\param.elk') Then Begin
    If DisplayLinkerError('Parameter file',BuildDir+'\Param.elk','Parameter file') then Exit;
  End;

  // State 0..NbState
  For i:=0 to NbState do begin
    If FileExists(BuildDir+'\state'+intToStr(i)+'.elk') Then Begin
      if DisplayLinkerError('State'+intToStr(i),BuildDir+'\state'+intToStr(i)+'.elk',Scr.StateFiles[i]) then Exit;
    End;
  End;
  TestLinkerOutput:=True;
End;


Function TFMain.TestLinkerOutputCommon(BuildDir:String;NbState:Integer):Boolean;
Var i:integer;
Begin
  TestLinkerOutputCommon:=False;
  //Common
  If FileExists(BuildDir+'\Common.elk') Then Begin
    If DisplayLinkerError('Common State',BuildDir+'\Common.elk',Scr.CommonFiles+Scr.BackFiles) then Exit;
  End;
  TestLinkerOutputCommon:=True;
End;


Function TFMain.TestLinkerOutputParam(BuildDir:String;NbState:Integer):Boolean;
Var i:integer;
Begin
  TestLinkerOutputParam:=False;
  //Parameter file
  If FileExists(BuildDir+'\param.elk') Then Begin
    If DisplayLinkerError('Parameter file',BuildDir+'\Param.elk','Parameter file') then Exit;
  End;
  TestLinkerOutputParam:=True;
End;


Function TFMain.TestLinkerOutputState(BuildDir:String;NbState:Integer):Boolean;
Var i:integer;
Begin
  TestLinkerOutputState:=False;
  // State 0..NbState
  For i:=0 to NbState do begin
    If FileExists(BuildDir+'\state'+intToStr(i)+'.elk') Then Begin
      if DisplayLinkerError('State'+intToStr(i),BuildDir+'\state'+intToStr(i)+'.elk',Scr.StateFiles[i]) then Exit;
    End;
  End;
  TestLinkerOutputState:=True;
End;


//-- Called when the windows is created --
Function TFMain.GenerateWristapp(BuildDir:String;NbState:Integer):Boolean;
Var
  i,j,
  FillNb,
  TotalSize,
  HeaderSize,
  TotalStateSize,
  TmpAddr : integer;
  f:TFByte;
  Ok:Boolean;
begin
  Ok:=True;
  //NbState:=NbState;

  //-- Load Common state --
  LoadState(BuildDir+'\Common.sre',Common);
  //Msg(Format('Common = Addr:%6x  Size:%d',[Common.Addr,Common.Size]));
  Common.ReservedByte:=0;
  Common.WristappSize:=Common.Size+3; //+3 for the size (+2) and reserved byte (+1)

  TotalStateSize:=Common.Size+3; //+3 for the size (+2) and reserved byte (+1)

  //-- Load States --
  For i:=0 to NbState-1 do begin
    LoadState(BuildDir+'\State'+intToStr(i)+'.sre',State[i]);
    State[i].ReservedByte:=1;
    State[i].WristappSize:=State[i].Size+3; //+3 for the size (+2) and reserved byte (+1)

    //Msg(Format('State %d = Addr:%6x  Size:%d',[i,State[i].Addr,State[i].Size]));

    TotalStateSize:=TotalStateSize+State[i].Size+3; //+3 for the size (+2) and reserved byte (+1)
  End;

  //-- Calculate the header --
  HeaderSize:=7+NbState*2+2;  //+2 for the common state
  Common.WristappAddr:=HeaderSize-7; //-7 in order to have the internal address

  //Msg(Format('Common : Addr:%4d  Size:%4d',[Common.WristappAddr,Common.WristappSize]));
  TmpAddr:=Common.WristappAddr+Common.WristappSize;

  For i:=0 to NbState-1 do begin
    State[i].WristappAddr:=TmpAddr;

    TmpAddr:=TmpAddr+State[i].WristappSize;
    //Msg(Format('State%2d: Addr:%4d  Size:%4d',[i,State[i].WristappAddr,State[i].WristappSize]));
  End;

  //-- Wristapp generation --
  AssignFile(f,BuildDir+'\'+Scr.FolderName+'_code_018.bin');
  Rewrite(f);

  //Database size
  // On calcule 'Database size'
  j:=State[NbState-1].WristappAddr+State[NbState-1].WristappSize+7;
  //msg('Database size='+IntToStr(j));

  //Allocation size
  // On calcule 'Allocation size'. Dpend de database size puisque c'est allocation size au multiple de 64 suivant.
  i:=(((j-1) div 64)+1)*64;
  //Msg('Allocation Size ='+IntToStr(i));
  WriteWord(f,i);
  WriteWord(f,j);
  FillNb:=i-j-1;
  WristappSize:=i;

  //Header size
  // On n'a pas de header dans une wristapp => 2
  WriteByte(f,2);

  //Number of record
  // nombre de state (de 0  x) plus le 'common state'
  WriteWord(f,NbState+1);

  WriteWord(f,Common.WristappAddr);
  For i:=0 to NbState-1 do
    WriteWord(f,State[i].WristappAddr);

  // Common data
  WriteWord(f,Common.WristappSize);
  WriteByte(f,Common.ReservedByte);
  For i:=0 to Common.Size-1 do
    WriteByte(f,Common.Data[i]);

  // States data
  For j:=0 to NbState-1 do begin
    WriteWord(f,State[j].WristappSize);
    WriteByte(f,State[j].ReservedByte);
    For i:=0 to State[j].Size-1 do
      WriteByte(f,State[j].Data[i]);
  End;

  // Fill the end of the file with 0
  For i:=0 to FillNb do
    WriteByte(f,0);

  CloseFile(f);
end;



//-- Load a state from disk and store it in memory --
Procedure TFMain.LoadState(Name:String;Var BState:TState);
Var
  f : textfile;
  s: string;
  i,j,p,BlockSize : integer;
  first:boolean;
begin
  assignfile(f,Name);
  reset(f);
  First:=True;
  P:=0;
  while not (eof(f)) do begin
    readln(f,s);
    if (s[1]='S') and (s[2]='0') then begin  // Header
      // We don't care of this line
    end
    else if (s[1]='S') and (s[2]='2') then begin  // Data block
      //Read the block size
      BlockSize:=Hex2Dec(s[3],s[4]);

      //Read the block address
      if First then begin
        BState.Addr:=HexAddr2Dec(Copy(s,5,6));
        First:=False;
      End;

      //Read the datas
      i:=0;
      While (i<BlockSize-3-1) do begin
        j:=Hex2Dec(s[11+i*2],s[11+1+i*2]);
        BState.Data[P]:=J;
        inc(P);
        inc(i);
      End;
    end
    else if (s[1]='S') and (s[2]='8') then begin  // End block
      // We don't care of this line
    end;
  end;
  closefile(f);
  BState.Size:=p;
end;


//-- Load a Param SRE file and generate the BIN file --
Function TFMain.GenerateParam(SrcName,DstName:String):Boolean;
Var
  fd : TFByte;
  f : textfile;
  s: string;
  i,j,p,BlockSize : integer;
  first:boolean;
  data : array[1..28] of byte;
begin
  GenerateParam:=True;
  if FileExists(SrcName) then begin
    assignfile(f,SrcName);
    reset(f);
    First:=True;
    P:=0;
    while not (eof(f)) do begin
      readln(f,s);
      if (s[1]='S') and (s[2]='0') then begin  // Header
        // We don't care of this line
      end
      else if (s[1]='S') and (s[2]='2') then begin  // Data block
        //Read the block size
        BlockSize:=Hex2Dec(s[3],s[4]);

        //Read the block address
  {
        if First then begin
          BState.Addr:=HexAddr2Dec(Copy(s,5,6));
          First:=False;
        End;
  }
        //Read the datas
        i:=0;
        While (i<BlockSize-3-1) do begin
          j:=Hex2Dec(s[11+i*2],s[11+1+i*2]);
          data[i+1]:=J;
          inc(P);
          inc(i);
        End;
      end
      else if (s[1]='S') and (s[2]='8') then begin  // End block
        // We don't care of this line
      end;
    end;
    closefile(f);
    //-- Data to disk --

    assignFile(fd,DstName);
    rewrite(fd);

    For i:=1 to 9 do
      WriteByte(fd,Data[i]);
    WriteWord(fd,WristappSize);
    For i:=12 to 28 do
      WriteByte(fd,Data[i]);
    closefile(fd);
  End
  else begin  //File error
    Msg('[!] The parameter file doesn'#39't exist.');
    GenerateParam:=False;
  End;
end;



procedure TFMain.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  Case key of
    120 : Build; // F9
    27 : FMain.FormStyle:=fsNormal;
  End;
end;


procedure TFMain.LoadScr(Name:String);
var
  ft  : TextFile;
  s   : String;
  k,l,i : Integer;
begin
  //-- Read the builder file --

  Status:=0;
  BiggestState:=0;
  WristappSize:=0;
  DisplayResume;
  InitSG;
  
  assignfile(ft,Name);
  system.Reset(ft);

  Readln(ft,Scr.AppName);
  Readln(ft,Scr.FolderName);
  Readln(ft,Scr.Description);
  Readln(ft,Scr.BannerLine);
  Readln(ft,Scr.BannerLine2);
  Readln(ft,Scr.VersionRequired);
  Readln(ft,S);
  Scr.PasswordSupport:=StrToInt(S);

  Readln(ft,S);
  Scr.DatabaseSupport:=StrToInt(S);

  Readln(ft,Scr.PCInterface);
  Readln(ft,Scr.HeaderDir);
  Readln(ft,Scr.SourceDir);
  Readln(ft,Scr.BuildDir);
  Readln(ft,Scr.IncludeDir);
  Readln(ft,Scr.AssemblerDir);

  Readln(ft,S);
  Scr.NbSource:=StrToInt(S);

  //Number of parameter file
  Readln(ft,S);
  Scr.NbParamFile:=StrToInt(S);
  For k:=1 to Scr.NbParamFile do begin
    Readln(ft,Scr.ParamFile[k]);
  End;

  Readln(ft,S);
  Scr.NbHeaderFile:=StrToInt(S);
  Scr.HeaderFiles:='';
  For k:=1 to Scr.NbHeaderFile do begin
    Readln(ft,Scr.HeaderFile[k]);
    Scr.HeaderFiles:=Scr.HeaderFiles+ExtractFileName(Scr.HeaderFile[k])+' ';
  End;

  Readln(ft,S);
  Scr.NbBackFile:=StrToInt(S);
  Scr.BackFiles:='';
  For k:=1 to Scr.NbBackFile do begin
    Readln(ft,Scr.BackFile[k]);
    Scr.BackFiles:=Scr.BackFiles+ExtractFileName(Scr.BackFile[k])+' ';
  End;

  Readln(ft,S);
  Scr.NbCommonFile:=StrToInt(S);
  Scr.CommonFiles:='';
  For k:=1 to Scr.NbCommonFile do begin
    Readln(ft,Scr.CommonFile[k]);
    Scr.CommonFiles:=Scr.CommonFiles+ExtractFileName(Scr.CommonFile[k])+' ';
  End;

  For l:=0 to (Scr.NbSource-4-1) do begin
    Readln(ft,S);
    Scr.NbStateFile[l]:=StrToInt(S);
    Scr.StateFiles[l]:='';
    For k:=1 to Scr.NbStateFile[l] do begin
      Readln(ft,Scr.StateFile[l,k]);
      Scr.StateFiles[l]:=Scr.StateFiles[l]+ExtractFileName(Scr.StateFile[l,k])+' ';
    End;
  End;
  Closefile(ft);

  // Find the last used state
  l:=Scr.NbSource-4-1;
  While (l>=0) and (Scr.NbStateFile[l]=0) do
    Dec(l);
  NbProjectState:=l;

  SGAnalyze.RowCount:=Scr.NbSource+4;


  With SGAnalyze do begin
    Cells[4,1]:=Scr.HeaderFiles;
    Cells[4,2]:=Scr.BackFiles;
    Cells[4,3]:=Scr.CommonFiles;
    For i:=0 to Scr.NbSource-1 do begin
      If (i<=NbProjectState) then begin
        Cells[4,4+i]:=Scr.StateFiles[i];
      End
      Else Begin
        Cells[1,4+i]:='';
        Cells[2,4+i]:='';
        Cells[3,4+i]:='';
        Cells[4,4+i]:='';
      End;
    End; //For
  End; //With

  ScrFileAge:=FileAge(Name);
end;


procedure TFMain.BtLoadClick(Sender: TObject);
var
  ft  : TextFile;
  s   : String;
  k,l : Integer;
begin
  OpenDialog.InitialDir:=ProjectDir;
  if OpenDialog.Execute then begin
    ProjectName:=OpenDialog.FileName;
    EdProjectName.Text:=ProjectName;
    ProjectDir:=ExtractFilePath(ProjectName);

    LoadScr(ProjectName);
  End;
end;


procedure TFMain.BtBuildClick(Sender: TObject);
begin
  Build;
end;


procedure TFMain.SGAnalyzeDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
begin
  With Sender As TStringGrid Do With Canvas Do
  Begin
    { slection de la couleur de fond }
    If gdFixed in State
      Then Brush.Color := clBtnFace
      Else If gdSelected In State
        Then Brush.Color := clNavy
        Else If (ACol=1) and (Cells[1,ARow]<>'') then Begin
          If Cells[1,ARow]='Error'
          Then Brush.Color := $0033FF
          Else Brush.Color := $00FF9E;
        End
        else Brush.Color := $FFFFFF;
    { Dessin du fond }
    FillRect(Rect);
    { Slection de la couleur d'criture }
    If gdSelected In State
      Then Font.Color:=clWhite
      Else Font.Color:=clBlack;
    { Dessin du texte }
    TextOut(Rect.Left,Rect.Top,Cells[ACol,ARow]);
  End;
end;

procedure TFMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
  SaveConfiguration;
end;

procedure TFMain.BtHelpClick(Sender: TObject);
begin
  FAbout.ShowModal;
end;


procedure TFMain.TestModifSCR;
begin
  If ProjectName='' then exit;
  If ScrFileAge<>FileAge(ProjectName) then begin
    ScrFileAge:=FileAge(ProjectName);
    if MessageDlg('The .SCR file was modified !'+#13+#10+'Reload it?',
                  mtConfirmation, [mbNo,mbYes], 0)=mrYes then begin
      LoadScr(ProjectName);
    end;
  end;
end;


procedure TFMain.ApplicationEventsActivate(Sender: TObject);
begin
  TestModifSCR;
end;


procedure TFMain.SGAnalyzeDblClick(Sender: TObject);
Var I:integer;
begin
  Case SGAnalyze.Row of
    1:  begin
          If Scr.NbHeaderFile>0 then begin
            For i:=1 to Scr.NbHeaderFile do begin
              ShellExecute(0,'OPEN',PChar(Editor),PChar(Scr.HeaderFile[i]),Nil, SW_SHOW);
            End;
          End;
        End;
    2:  begin
          If Scr.NbBackFile>0 then begin
            For i:=1 to Scr.NbBackFile do begin
              ShellExecute(0,'OPEN',PChar(Editor),PChar(Scr.BackFile[i]),Nil, SW_SHOW);
            End;
          End;
        End;
    3:  begin
          If Scr.NbCommonFile>0 then begin
            For i:=1 to Scr.NbCommonFile do begin
              ShellExecute(0,'OPEN',PChar(Editor),PChar(Scr.CommonFile[i]),Nil, SW_SHOW);
            End;
          End;
        End;
   Else begin
          If Scr.NbStateFile[SGAnalyze.Row-4]>0 then begin
            For i:=0 to Scr.NbStateFile[SGAnalyze.Row-4]-1 do begin
              ShellExecute(0,'OPEN',PChar(Editor),PChar(Scr.StateFile[SGAnalyze.Row-4,i+1]),Nil, SW_SHOW);
            End;
          End;
   End;
  End; //Case
end;


procedure TFMain.BtOptionsClick(Sender: TObject);
begin
  FrmOptions.Editor:=Editor;
  FrmOptions.CheckSize:=CheckSize;
  FrmOptions.SaveDb:=SaveDb;
  if FrmOptions.ShowModal = mrOK then begin
    Editor:=FrmOptions.Editor;
    CheckSize:=FrmOptions.CheckSize;
    SaveDb:=FrmOptions.SaveDb;
  End;
end;

end.