unit Options;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, StdCtrls;

type
  TFrmOptions = class(TForm)
    GroupBox1: TGroupBox;
    EdEditor: TEdit;
    GroupBox2: TGroupBox;
    ChkCheckStateSize: TCheckBox;
    BtChooseEditor: TButton;
    BtOk: TBitBtn;
    BtCancel: TBitBtn;
    OpenDialog: TOpenDialog;
    ChkSaveDb: TCheckBox;
    procedure BtOkClick(Sender: TObject);
    procedure BtChooseEditorClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Editor : String;
    CheckSize : Boolean;
    SaveDb : Boolean;
  end;

var
  FrmOptions: TFrmOptions;

implementation

{$R *.dfm}

procedure TFrmOptions.BtOkClick(Sender: TObject);
begin
  Editor:= EdEditor.Text;
  CheckSize:=ChkCheckStateSize.Checked;
  SaveDb:=ChkSaveDb.Checked;
end;

procedure TFrmOptions.BtChooseEditorClick(Sender: TObject);
begin
  If OpenDialog.Execute then begin
    EdEditor.Text:=OpenDialog.FileName;
  End;
end;

procedure TFrmOptions.FormShow(Sender: TObject);
begin
  EdEditor.Text:=Editor;
  ChkCheckStateSize.Checked:=CheckSize;
  ChkSaveDb.Checked:=SaveDb;
end;

end.
